package cn.ibizlab.core.rule.mapper;

import java.util.List;
import org.apache.ibatis.annotations.*;
import java.util.Map;
import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.core.conditions.Wrapper;
import java.util.Map;
import org.apache.ibatis.annotations.Select;
import cn.ibizlab.core.rule.domain.ExecResult;
import cn.ibizlab.core.rule.filter.ExecResultSearchContext;
import org.springframework.cache.annotation.CacheEvict;
import org.springframework.cache.annotation.Cacheable;
import java.io.Serializable;
import com.baomidou.mybatisplus.core.toolkit.Constants;
import com.alibaba.fastjson.JSONObject;

public interface ExecResultMapper extends BaseMapper<ExecResult> {

    Page<ExecResult> searchDefault(IPage page, @Param("srf") ExecResultSearchContext context, @Param("ew") Wrapper<ExecResult> wrapper);
    @Override
    ExecResult selectById(Serializable id);
    @Override
    int insert(ExecResult entity);
    @Override
    int updateById(@Param(Constants.ENTITY) ExecResult entity);
    @Override
    int update(@Param(Constants.ENTITY) ExecResult entity, @Param("ew") Wrapper<ExecResult> updateWrapper);
    @Override
    int deleteById(Serializable id);
    /**
    * 自定义查询SQL
    * @param sql
    * @return
    */
    @Select("${sql}")
    List<JSONObject> selectBySQL(@Param("sql") String sql, @Param("et")Map param);

    /**
    * 自定义更新SQL
    * @param sql
    * @return
    */
    @Update("${sql}")
    boolean updateBySQL(@Param("sql") String sql, @Param("et")Map param);

    /**
    * 自定义插入SQL
    * @param sql
    * @return
    */
    @Insert("${sql}")
    boolean insertBySQL(@Param("sql") String sql, @Param("et")Map param);

    /**
    * 自定义删除SQL
    * @param sql
    * @return
    */
    @Delete("${sql}")
    boolean deleteBySQL(@Param("sql") String sql, @Param("et")Map param);

    List<ExecResult> selectByRuleId(@Param("rule_id") Serializable rule_id);

}
